%define kmod_name		cciss
%define kmod_driver_version	3.6.28
%define kmod_rpm_release	2
%define kmod_git_hash		75c0a4e8151274cd989522336b3bdf56c5736c71
%define kmod_kernel_version	2.6.18-348.el5
%define kmod_kbuild_dir		drivers/block


%{!?dist: %define dist .el5_9}

Source0:	%{kmod_name}-%{kmod_driver_version}.tar.bz2			
Source1:	depmodconf			
Source2:	kmodtool			
Source3:	find-requires.ksyms			
Source4:	find-provides.ksyms			
Source5:	symbols.greylist-i686			
Source6:	symbols.greylist-i686PAE			
Source7:	symbols.greylist-i686xen			
Source8:	symbols.greylist-x86_64			
Source9:	symbols.greylist-x86_64xen			

Patch0:		cciss.patch

%define kmodtool bash %{SOURCE2}
%define __find_requires %_sourcedir/find-requires.ksyms %{_builddir}/%{name}-%{version}
%define __find_provides %_sourcedir/find-provides.ksyms %{kmod_name} %{?epoch:%{epoch}:}%{version}-%{release}

%define kverrel %(%{kmodtool} verrel %{kmod_kernel_version} 2>/dev/null)

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define paevar PAE
%endif

%define upvar ""
%{!?kvariants: %define kvariants %{?upvar} %{?xenvar} %{?paevar}}

Name:           %{kmod_name}
Version:        %{kmod_driver_version}
Release:        %{kmod_rpm_release}%{?dist}
Summary:        %{kmod_name} kernel module
Group:          System Environment/Kernel
License:        GPL
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686 x86_64


%description
%{kmod_name} - driver update

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kmod_kernel_version}  %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
cd %{kmod_name}-%{version}
%patch0 -p1
cd ..
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-%{version} _kmod_build_$kvariant
        cp %{SOURCE5} _kmod_build_$kvariant
cp %{SOURCE6} _kmod_build_$kvariant
cp %{SOURCE7} _kmod_build_$kvariant
cp %{SOURCE8} _kmod_build_$kvariant
cp %{SOURCE9} _kmod_build_$kvariant
done


%build
echo  %{kverrel}
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant

    # update symvers file if existing
    symvers=Module.symvers${kvariant:+-$kvariant}-%{_target_cpu}
    if [ -e $symvers ]; then
        cp $symvers %{kmod_kbuild_dir}/Module.symvers
    fi

    greylist=symbols.greylist-%{_target_cpu}$kvariant
    if [ -f $greylist ]; then
        cat $greylist >> ../symbols.greylist.tmp
    fi

    make -C "${ksrc}" modules M=$PWD/%{kmod_kbuild_dir} \
        NOSTDINC_FLAGS="-I $PWD/include"

    # mark modules executable so that strip-to-file can strip them
    find %{kmod_kbuild_dir} -name "*.ko" -type f -exec chmod u+x '{}' +

    popd
done

%{SOURCE1} %{kmod_name} %{kmod_kernel_version} _kmod_build_ > depmod.conf

greylist=symbols.greylist.tmp
if [ -f $greylist ]; then
	sort -u $greylist > symbols.greylist
else
	touch symbols.greylist
fi

if [ -d firmware ]; then
	make -C firmware
fi

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules_install M=$PWD/%{kmod_kbuild_dir}
    popd
done

mkdir -p ${RPM_BUILD_ROOT}/lib/firmware

install -m 644 -D depmod.conf $RPM_BUILD_ROOT/etc/depmod.d/%{kmod_name}.conf
install -m 644 -D symbols.greylist $RPM_BUILD_ROOT/usr/share/doc/kmod-%{kmod_name}/greylist.txt

if [ -d firmware ]; then
	make -C firmware INSTALL_PATH=$RPM_BUILD_ROOT INSTALL_DIR=updates install
fi

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Jun 29 2013 Weiping Pan <wpan@redhat.com> 3.6.28 2
- Update spec version 

* Tue Jun 25 2013 Weiping Pan <wpan@redhat.com> 3.6.28 1
- cciss DUP module
